use flatten::Flattener;
use parser::Parser;
use scanner::Scanner;

mod expr;
mod flatten;
mod parser;
mod scanner;
mod token;

fn main() {
    let scanner = Scanner::new(
        "
$false = λtf.f
$true = λtf.t

λa.(a $true)
",
    );

    let tokens = scanner.scan_tokens().unwrap();

    let mut parser = Parser::new(tokens);
    let (funcs, main) = parser.parse().unwrap();

    let mut flattener = Flattener::new(funcs);
    let flat = flattener.flatten(&main);

    dbg!(flat);
}
